

/******************************************************************/
/*            	Unlock program for em and xgeom		  	  */
/* Copyright (c) 1990 Sonnet Software, Inc., All rights reserved. */
/******************************************************************/

/* %W% last mod on %G% at %U% */
/* Full SCCS path name: (%P%) */

/*******************************************************************

	NAME: unnode.i
	
	AUTHOR: K. Schroeder
	
	PURPOSE: Common routine to node manipluations
	
	CONTENTS:
	add_sn() - Add a single node to the end of the list of nodes.
	
	
	
*******************************************************************/

/* definitions	*/

/* external	*/


/* structures and global/semiglobal variable */

/*******************************************************************
	NAME: add_sn()
	
	DESCRIPTION: 
		Add a single serial number to list of sn
	
	RETURNS: none

*******************************************************************/

void
add_sn(key,sn)
Key *key;
char *sn;
{
	int len;
	unsigned bytes;
	int i;

	len = strlen(sn);
	if ( key->nu_sn == NONE ) {
		key->nu_sn = 0;
	}
	
	/* Do not add duplicate sn */
	for (i=0; i<key->nu_sn; ++i) {
		if ( strcmp(key->sn[i],sn) == 0 ) {
			return;
		}
	}
	
	++key->nu_sn;
	bytes = key->nu_sn * sizeof(key->sn);
	if ( key->nu_sn == 1 ) {
		key->sn = (char **) new( (unsigned)bytes );
	} else {
		key->sn = (char **) rnew( (char *)key->sn, (unsigned)bytes);
	}
	bytes = len * sizeof(char) + 1;
	*(key->sn + key->nu_sn-1) = (char *)new( (unsigned)bytes );
	strcpy(key->sn[key->nu_sn-1],sn);
}

