#include "local.h"
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "son.h"
#include "em.typ"
#include "jxy.typ"
#include "complex2.h"
#include "patdata.h"

static char sw_version[] = { "@(#)SONNET'S PLOTTING PACKAGE: 3.0-prototype-1" };

void exit();
void perror();
extern char *get_version();
extern int hid_sn();

char prog_name[] = "patgen";

int
main(argc,argv)  
int argc; 
char *argv[];
{ 
  WPatData ad;
  WPatGenOpt opt;
  WPatGenTmp td;
  int good_key;

  /*Turn on malloc bug detection code*/
  /* Set env. variable DNEW to debug level, typically 2 */
  init_new();

  /* parse the command options */
  WPatGen_parse(argc,argv,&opt);
  
  /* read antenna configuration file */
  WPatGenFile_read(&opt,&td);

  /* Secruity - lock same as emvu */
  good_key = check_security( PROG_PATVU );
  if ( ! good_key ) exit(1);


  /* compute radiation pattern */
  WPatData_init(&td,&ad);

  if (opt.state_mem == YES) {
    printf("%10s: at least %d MB required.\n",prog_name,td.nbyte);
    exit(0);
  }

  if (opt.verbose == YES) 
    print_titlepage(&opt,&td);

  /* fill ad with output */
  WPatData_fill(&opt,&td,&ad);

  /* exit properly */
  exit(0);
}

exit_program(exit_nu)
int exit_nu;
{
	extern void exit();

	exit (exit_nu);
}


