
TOPDIR		= ../../..
SOURCE		= .
TARGET		= $(TOPDIR)/target/patgen
EM_TARGET	= $(TOPDIR)/target/em
EXECUTABLES	= $(TOPDIR)/target/bin
LIBRARIES	= $(TOPDIR)/target/lib
BIN		= $(TOP)/bin
TMP		= /tmp

PATGEN_LD	=
GEN_LDFLAGS	=
PATGEN_CFLAGS	= 
GEN_CFLAGS	= 

EXT		= o
CP		= cp
CC		= cc
MV		= mv
LIB		= -L $(LIBRARIES) -lm -lson 
RM		= rm -f
OPTIMIZE	=
OPTS		= 
HEAD_INCLUDE	= -I../include
PRODUCTS	= $(EXECUTABLES)/patgen

############# LOCAL DEFINITIONS - BEGIN

#### HP700
#DEFINES = -DHP -DHP700
#PATGEN_LD =
#GEN_LDFLAGS=
#OPTS = -Aa
#MACH = laura
#EM_TARGET = /andy/mfg_tmp/target/em
#CP = cp

#### IBM
#DEFINES=-DIBM -DIBM6000
#GEN_LDFLAGS= -bnso -lc -bI:/lib/syscalls.exp
#OPTS = -g
#MACH = sue
#EM_TARGET = /sue/mfg/target/em
#CP = cp

#### SUN
# DEFINES =  -DUNIX -DSPARC -DSUN -DMALLOC_H
# OPTS = -g -fsingle
# MACH = andy
# EM_TARGET = .
# CP = cp

#### APOLLO
# DEFINES = -DUNIX -DAPOLLO -DAP3 -DNO_MALLOC_H
# XGEOM_LD = 
# MACH = jean
 
# TARGET = .
# EXECUTABLES = .
# BIN = .
# MV = echo
# HEAD_INCLUDE = -I/$(MACH)/local/include
# LIB =  -L/$(MACH)/local/lib -lm -lson 
# HEAD_INCLUDE = -I/home/mfg/base/src/lib/son -I/home/mfg/base/src/include
# LIB =  -L/home/mfg/target/lib -lm -lson
 

############# LOCAL DEFINITIONS END 


########################## OPTIONS FOR DOS

DVX			= C:/dvx
HIGHC			= C:/highc
PHAR386			= C:/phar386
COPROCESSOR		= 387
CC		= hc386
LD		= 386link
BIND		= bind386
BIND_MODULE	= $(PHAR386)/bin/run386b.exe
MFG		= 
TARGET		= $(MFG)/target/patgen
EXECUTABLES	= $(MFG)/target/bin
EXT		= obj
PRODUCTS	= $(EXECUTABLES)/patgen.exe
MV		= mv
DEFINES		= -DDOS
GEN_CFLAGS	= @cflags.rsp -f$(COPROCESSOR)
LIB		= 
PATGEN_LD		=



STD_DEFINES	= -DEXCLUDE_VEC
CFLAGS		= $(CDBUGFLAGS) $(HEAD_INCLUDE) $(STD_DEFINES) $(DEFINES) \
		  $(OPTS) $(OPTIMIZE) $(PATGEN_CFLAGS) $(GEN_CFLAGS)
LDFLAGS		= $(OPTIMZE) $(LIB) $(PATGEN_LD) $(GEN_LDFLAGS)
# SHELL		= /bin/sh
RM_CMD		= $(RM) $(TARGET)/*.o $(PRODUCTS) $(TARGET)/*.tags

PATGEN_HEADERS = \
		complex2.h \
		em.typ \
		jxy.typ

SECURITY_DEPEND =	\
		keyfile.h \
		unlcki_p.h \
		security.i \
		rkeyfile.i \
		date.i \
		crypt.i \
		crypt2.i \
		unnode.i \
		wkeystr.i \
		getnode.i

all::	$(PRODUCTS)

PATGEN_OBJS = \
		$(TARGET)/patgen.$(EXT) \
		$(TARGET)/patgenio.$(EXT) \
		$(TARGET)/patgenfl.$(EXT) \
		$(TARGET)/wstr.$(EXT) \
		$(TARGET)/putil.$(EXT)

DOS_OBJS =

EM_OBJS = \
		$(TARGET)/fmtnum.$(EXT) \
		$(TARGET)/version.$(EXT) \
		$(TARGET)/emin.$(EXT) \
		$(TARGET)/msubutil.$(EXT) \
		$(TARGET)/polyutil.$(EXT) \
		$(TARGET)/emhead.$(EXT) \
		$(TARGET)/readpoly.$(EXT) \
		$(TARGET)/ptlist.$(EXT) \
		$(TARGET)/annfile.$(EXT)

JXY_OBJS = \
		$(TARGET)/jutil.$(EXT) \
		$(TARGET)/sparm.$(EXT) \
		$(TARGET)/vecall.$(EXT)


SRC = \
		$(SOURCE)/patgen.c \
		$(SOURCE)/patgenio.c \
		$(SOURCE)/patgenfl.c \
		$(SOURCE)/wstr.c \
		$(SOURCE)/putil.c \
		$(SOURCE)/fmtnum.c \
		$(SOURCE)/version.c \
		$(SOURCE)/emin.c \
		$(SOURCE)/msubutil.c \
		$(SOURCE)/polyutil.c \
		$(SOURCE)/emhead.c \
		$(SOURCE)/readpoly.c \
		$(SOURCE)/ptlist.c \
		$(SOURCE)/annfile.c


#################################
#           			#
#           BUILD PATGEN     	#
#           			#
#################################

patgen:		$(EXECUTABLES)/patgen


$(EXECUTABLES)/patgen: $(PATGEN_OBJS) $(JXY_OBJS) $(EM_OBJS)
		$(CC) $(PATGEN_OBJS) $(JXY_OBJS) $(EM_OBJS) $(LDFLAGS) -o $(EXECUTABLES)/patgen

patgen: $(PATGEN_OBJS) $(JXY_OBJS) $(EM_OBJS)
		$(CC) $(PATGEN_OBJS) $(JXY_OBJS) $(EM_OBJS) $(LDFLAGS) -o $(EXECUTABLES)/patgen



#################################
#           			#
#        DOS SUPPORT		#
#           			#
#################################

$(EXECUTABLES)/patgen.exe: $(EXECUTABLES)/patgen.exp
	$(BIND) $(BIND_MODULE) $(EXECUTABLES)/patgen.exp -exe $(EXECUTABLES)/patgen.exe

$(EXECUTABLES)/patgen.exp: $(PATGEN_OBJS) $(EM_OBJS) $(DOS_OBJS) $(JXY_OBJS) cflags.rsp link.rsp objs.rsp
	$(LD) @link.rsp @objs.rsp $(LDFLAGS) -exe $(EXECUTABLES)/patgen.exp


objs.rsp::
	echo $(PATGEN_OBJS) $(EM_OBJS) $(JXY_OBJS) $(DOS_OBJS) | dosobj > objs.rsp

link.rsp::
	echo -LIB $(DVX)/lib/hc386/Xext		>  link.rsp
	echo -LIB $(DVX)/lib/hc386/Xlib		>> link.rsp
	echo -LIB $(DVX)/lib/hc386/sysphar	>> link.rsp
	echo -LIB $(LIBRARIES)/libson          >> link.rsp
	echo -LIB $(HIGHC)/small/hc$(COPROCESSOR) >> link.rsp
	echo -LIB $(HIGHC)/small/hcloc          >> link.rsp
	echo -LIB $(HIGHC)/small/hc386          >> link.rsp
	echo -LIB $(HIGHC)/small/hcna           >> link.rsp
	echo -LIB C:/glenco/hl386hc.lib         >> link.rsp
	echo -STACK 40000                       >> link.rsp
	echo -cvsymbols                         >> link.rsp
	echo -priv                         	>> link.rsp 

cflags.rsp::
	> cflags.rsp
	echo -O5                                >> cflags.rsp
	echo -Hoff=Low_level_scheduling         >> cflags.rsp
	echo -w                                 >> cflags.rsp
	echo -486                               >> cflags.rsp
	echo -Hnocopyr                          >> cflags.rsp
	echo -Hon=Pointers_compatible           >> cflags.rsp
	echo -Hon=Pointers_compatible_with_ints >> cflags.rsp
	echo -DMSDOS                            >> cflags.rsp
	echo -I$(DVX)/include                	>> cflags.rsp
	echo -I../include                	>> cflags.rsp 
	


#################################
#           			#
#        LINK ONLY		#
#           			#
#################################


patgen.obj:	$(PATGEN_OBJS)


#################################
#           			#
#        LINK MODULES		#
#           			#
#################################


####
####
####   BUILD PATGEN
####
####

$(TARGET)/patgen.$(EXT):   patgen.c $(PATGEN_HEADERS)
		$(CC) patgen.c $(CFLAGS) -c
		$(MV) patgen.$(EXT) $(TARGET)

$(TARGET)/patgenio.$(EXT):   patgenio.c $(PATGEN_HEADERS)
		$(CC) patgenio.c $(CFLAGS) -c
		$(MV) patgenio.$(EXT) $(TARGET)

$(TARGET)/patgenfl.$(EXT):   patgenfl.c $(PATGEN_HEADERS)
		$(CC) patgenfl.c $(CFLAGS) -c
		$(MV) patgenfl.$(EXT) $(TARGET)

$(TARGET)/wstr.$(EXT):   wstr.c $(PATGEN_HEADERS)
		$(CC) wstr.c $(CFLAGS) -c
		$(MV) wstr.$(EXT) $(TARGET)

$(TARGET)/putil.$(EXT):   putil.c $(PATGEN_HEADERS) patdata.h
		$(CC) putil.c $(CFLAGS) -c
		$(MV) putil.$(EXT) $(TARGET)

####
####
####	GENERIC ROUTINES
####
####


$(TARGET)/version.$(EXT): version.c version.h  sccs.h
		$(CC) version.c $(CFLAGS) -c
		$(MV) version.$(EXT) $(TARGET)

$(TARGET)/fmtnum.$(EXT): fmtnum.c em.typ
		$(CC) fmtnum.c $(CFLAGS) -c
		$(MV) fmtnum.$(EXT) $(TARGET)



####
####
#### ROUTINES FROM EM
####
####

$(TARGET)/emin.$(EXT) : emin.c $(SECURITY_DEPEND)
		$(CC) emin.c $(CFLAGS) -c
		$(MV) emin.$(EXT) $(TARGET)


$(TARGET)/msubutil.$(EXT): msubutil.c $(PATGEN_HEADERS)
		$(CC) msubutil.c $(CFLAGS) -c
		$(MV) msubutil.$(EXT) $(TARGET)

$(TARGET)/polyutil.$(EXT): polyutil.c $(PATGEN_HEADERS)
		$(CC) polyutil.c $(CFLAGS) -c
		$(MV) polyutil.$(EXT) $(TARGET)

$(TARGET)/emhead.$(EXT): emhead.c $(PATGEN_HEADERS)
		$(CC) emhead.c $(CFLAGS) -c
		$(MV) emhead.$(EXT) $(TARGET)

$(TARGET)/readpoly.$(EXT): readpoly.c $(PATGEN_HEADERS)
		$(CC) readpoly.c $(CFLAGS) -c
		$(MV) readpoly.$(EXT) $(TARGET)

$(TARGET)/ptlist.$(EXT) : ptlist.c $(PATGEN_HEADERS)
		$(CC) ptlist.c $(CFLAGS) -c
		$(MV) ptlist.$(EXT) $(TARGET)

$(TARGET)/annfile.$(EXT) : annfile.c $(PATGEN_HEADERS)
		$(CC) annfile.c $(CFLAGS) -c
		$(MV) annfile.$(EXT) $(TARGET)

####
####
#### ROUTINES COPIES EM
####
####

$(TARGET)/jutil.$(EXT) : $(EM_TARGET)/jutil.$(EXT)
		$(CP) $(EM_TARGET)/jutil.$(EXT) $(TARGET)/jutil.$(EXT)

$(TARGET)/vecall.$(EXT) : $(EM_TARGET)/vecall.$(EXT)
		$(CP) $(EM_TARGET)/vecall.$(EXT) $(TARGET)/vecall.$(EXT)

$(TARGET)/sparm.$(EXT) : $(EM_TARGET)/sparm.$(EXT)
		$(CP) $(EM_TARGET)/sparm.$(EXT) $(TARGET)/sparm.$(EXT)

clean::
	$(RM) $(RM_CMD)

lint::
	lint $(DEFINES) $(STD_DEFINES) -DUNIX $(SRC)
	 

####### Determine if there are any unnecessary files in directory
####### NOTE: must build product first

check_src::
	ls $(PATGEN_OBJS) $(SECURITY_DEPEND) $(PATGEN_HEADERS) \
		Makefile ref_files tags \
		check.c \
		sccs.h timeout.h version.h \
	    | sed "s+.*patgen/++" | sed "s+\.o+.c+" | grep -v $(BITMAPS) \
	    |sort> $(TMP)/src
	ls | grep -v $(BITMAPS) > $(TMP)/tmpls
	sort $(TMP)/tmpls > $(TMP)/ls
	diff $(TMP)/ls $(TMP)/src
	 
lint::
	lint $(DEFINES) -DUNIX $(SRC)

patgen.inp: makefile
	echo "defineg DOS"		> patgen.inp
	echo "defineg EXCLUDE_VEC"	>> patgen.inp
	echo "defineg MALLOC_H"		>> patgen.inp
	echo "defineg NO_EM_SECURITY"  	>> patgen.inp
	echo "ipath /base/src/include;c:/dvx/include;c:/c600/include" >> patgen.inp
	ls $(SRC) $(DOS_SRC) | sed "s+$(SOURCE)/++g" | sed "s/^/load /" >> patgen.inp
	echo "trace announce_bug"  	>> patgen.inp
	echo "shell c:"  		>> patgen.inp
	echo "shell cd \\tmp"  		>> patgen.inp
	echo "savemod patgen"  		>> patgen.inp
	echo "shell h:"  		>> patgen.inp
	echo Created patgen.inp

