

/******************************************************************/
/*            	Unlock program for em and xgeom		  	  */
/* Copyright (c) 1990 Sonnet Software, Inc., All rights reserved. */
/******************************************************************/

/* %W% last mod on %G% at %U% */
/* Full SCCS path name: (%P%) */

/*******************************************************************

	NAME: unnode.i
	
	AUTHOR: K. Schroeder
	
	PURPOSE: Common routine to node manipluations
	
	CONTENTS:
	add_node() - Add a single node to the end of the list of nodes.
	tolowerstr()  - Converts string to lower case.
	get_node_id() - get node id for present machine
	
	
	
*******************************************************************/

/* definitions	*/

/* external	*/


/* structures and global/semiglobal variable */

/*******************************************************************
	NAME: add_node()
	
	DESCRIPTION: 
		Add a single node to the end of the list of nodes.
	
	RETURNS: none

*******************************************************************/

void
add_node(prog,node)
Prog *prog;
char *node;
{
	int len;
	unsigned bytes;
	int i;

	len = strlen(node);
	if ( prog->nu_nodes == NONE ) {
		prog->nu_nodes = 0;
	}
	
	/* Do not add duplicate nodes */
	for (i=0; i<prog->nu_nodes; ++i) {
		if ( strcmp(prog->nodes[i],node) == 0 ) {
			return;
		}
	}
	
	++prog->nu_nodes;
	bytes = prog->nu_nodes * sizeof(prog->nodes);
	if ( prog->nodes == NULL ) {
		prog->nodes = (char **) new( (unsigned)bytes );
	} else {
		prog->nodes = (char **) rnew( (char *)prog->nodes, (unsigned)bytes);
	}
	bytes = len * sizeof(char) + 1;
	*(prog->nodes + prog->nu_nodes-1) = (char *)new( (unsigned)bytes );
	strcpy(prog->nodes[prog->nu_nodes-1],node);
}

/*******************************************************************
	NAME: tolowerstr()
	
	DESCRIPTION: 
		Converts string to lower case.
	
	RETURNS: none

*******************************************************************/

void
tolowerstr(string)
char *string;
{
	while ( *string != '\0' ) {
		if ( isupper( *string) ) {
			*string = tolower(*string);
		}
		++string;
	}
}
