#include <stdio.h>

#include "local.h"
#include "son.h"

extern char prog_name[];
static int IsToken();

/* 
 * char *Wstr_extract(str,substr)
 *
 * extract a useful substring: delete the leading white spaces,
 *   trucate at '#', and delete trailing white spaces
 *  tw021792
 */
int
  WStr_extract(str,substr)
char *str;
char *substr;
{
  char s[256];
  char *pstr,*pstr2,*pstr3;
  extern char *strchr();

  if (str == NULL || strlen(str) == 0) return(0);

  /* delete leading white space */
  strcpy(s,str);
  pstr=s;
  while (pstr != NULL && *pstr != '\0' && *pstr <= ' ' ) 
    pstr++;
  if (pstr==NULL || strlen(pstr) == 0) return (0);

  /* truncate at '#' */
  pstr2=strchr(pstr,'#');
  if (pstr2) pstr2[0]='\0';
  if (pstr == NULL || strlen(pstr) == 0) return(0);
  
  /* delete trailling white space */
  pstr2=pstr+strlen(pstr)-1;
  while (pstr2 != NULL && *pstr2 != '\0' && *pstr2 <= ' ') 
    pstr2--;
  if (pstr2) pstr2[1]='\0';
  if (pstr == NULL || strlen(pstr) == 0) return (0);
  strcpy(substr,pstr);
  return(1);
}

/*
 * int Wstr_separte(str,tokens,list)
 * 
 * seperate s list of items from a string sepeated by tokens
 *
 * tw021793
 */
int
  WStr_seperate(str,tokens,list)
char *str;
char *tokens;
char *list;
{
  int nitem;
  int p_token=1;
  char *pstr;
  char *plist;

  if (str == NULL || list == NULL) return(NULL);
  if (tokens == NULL) {
    return (0);
  }

  pstr=str;
  plist=list;
  nitem=1;
  while(pstr != NULL && strlen(pstr) > 0) {
    if (IsToken(*pstr,tokens)) {
      if (!p_token) {
	*plist='\0';
	p_token=1;
	nitem++;
	plist++;
      }
    }
    else {
      *plist= *pstr;
      p_token=0;
      plist++;
    }
    pstr++;
  }
  *plist='\0';
  return(nitem);
}

static int
  IsToken(ch,tokens)
char ch;
char *tokens;
{
  char *ptokens;

  ptokens=tokens;
  while (ptokens != NULL && strlen(ptokens) > 0) {
    if (ch == *ptokens) return(1);
    ptokens++;
  }
  return(0);
}
   
/*
 * Copy a string to another
 *
 */
char *
  WStr_copy(str)
char *str;
{
  int len;
  char *p;

  p = string(str);
}

/*
 * Create a file name with the same base name but different extension
 *
 */
char *
  WFile_ext(file,ext)
char *file;
char *ext;
{
  int len;
  char *p, *newfile;
  extern char *strchr();

  len=strlen(file)+2+strlen(ext);
  newfile=(char *)new(len*sizeof(char));
  strcpy(newfile,file);
  p=strchr(newfile,'.');
  if (p) p[0]='\0';
  strcat (newfile,".");
  strcat(newfile,ext);
  return (newfile);
}
    
/*
 * FILE *WFile_open(file,mode)
 *  open a file
 * 
 */
FILE 
  *WFile_open(file,mode)
char *file,*mode;
{
  FILE *fptr;

  if (file == NULL || mode == NULL) {
    fprintf(stderr,"%s: no file or mode is specified.\n",prog_name);
    exit(1);
  }
  fptr=fopen(file,mode);
  if (fptr == NULL) {
    fprintf(stderr,"%s: cannot open the file %s\n",prog_name,file);
    exit(1);
  }
  return (fptr);
}
  
/*
 *  int IsCharDigit(char ch)
 *   Check if the char is a digit including '+','-','.'
 *   if not , return NO=-1
 *   if yes,  return 0
 */
int
  IsCharDigit(ch)
char ch;
{
  if (ch == '+' || ch == '-' || ch == '.' ||
     ( ch >= '0' && ch <= '9')) return(0);
  else                       return(-1);
}

/*
 * void WFile_copy(FILE *infptr,outfptr)
 *   copy a file to another 
 */
void
  WFile_copy(infptr,outfptr)
FILE *infptr;
FILE *outfptr;
{
  char line[256];

  while (fgets(line,256,infptr) != NULL) 
    fputs(line,outfptr);
}

/*
 * int WFile_search(FILE *fptr,char *str,*line)
 *  search a str in a file 
 * return 1 until found, otherwise return 0
 *
 */
int
  WFile_search(fptr,str,line)
FILE *fptr;
char *str;
char *line;
{
  char subline[256];

  while (fgets(line,256,fptr) != NULL) 
    if (WStr_extract(line,subline) != 0 && 
      strncasecmp(subline,str,strlen(str)) == 0)
      return (1);
  
  return (0);
}


/*
 * int WStr_token(char *str,char *tokens)
 *
 *   determine if str contains any token in tokens
 */
int
  WStr_tokens(str,tokens)
char *str;
char *tokens;
{
  char *p;

  if (tokens == NULL) return (1);
  if (str == NULL) return (0);

  p=str;
  while (p && strlen(p) > 0) 
    if (IsToken(*p++,tokens)) return (1);

  return (0);
}
/*
 * char *WTime_local(void)
 *   return current local time in str format 
 * very bad. Should modify later
 *
 */
#include <time.h>

void
  WTime_local(str)
char *str;
{
  long clock=1L;
  extern char *ctime();

  if (str == NULL) return;
  time (&clock);
  strcpy(str,ctime(&clock));
}

/*
#include <sys/time.h>
#include <sys/resource.h>
	  
static struct rusage time_ref;

void
  WTimer_start()
{
  getrusage(RUSAGE_SELF,&time_ref);
}

void
  WTimer_cur(str,id)
char *str;
int id;
{
  struct rusage time_cur;
  long user_tsec,user_tusec,user_t,user_min,user_sec;
  long sys_tsec,sys_tusec,sys_t,sys_min,sys_sec;
  long real_tsec,real_tusec,real_t,real_min,real_sec;

  getrusage(RUSAGE_SELF,&time_cur);
  user_tsec=time_cur.ru_utime.tv_sec-time_ref.ru_utime.tv_sec;
  sys_tsec =time_cur.ru_stime.tv_sec-time_ref.ru_stime.tv_sec;
  user_tusec=time_cur.ru_utime.tv_usec-time_ref.ru_utime.tv_usec;
  sys_tusec =time_cur.ru_stime.tv_usec-time_ref.ru_stime.tv_usec;
  user_t=user_tsec+user_tusec*1e-06+0.5;
  sys_t=sys_tsec+sys_tusec*1e-06+0.5;
  real_t=user_t+sys_t;

  user_min=user_t/60;
  sys_min = sys_t/60;
  real_min=real_t/60;
  user_sec=user_t-user_min*60;
  sys_sec= sys_t-sys_min*60;
  real_sec=real_t-real_min*60;
  
  sprintf(str,"%d:%02d user,%d:%02d system, %d:%02d real",
	  user_min,user_sec,
	  sys_min,sys_sec,
	  real_min,real_sec);

  if (id) WTimer_start();
}
	  
*/
  
  
      
      
      
	
      
